#include "OgrePlatformOcclusionQuery.h"
#include <windows.h>
namespace Ogre {

//-----------------------------------------------------------------------
PlatformOcclusionQuery::PlatformOcclusionQuery(RenderSystem *rsys)
{
	mHardwareOcclusionQuery = rsys->createHardwareOcclusionQuery();
}
//-----------------------------------------------------------------------
PlatformOcclusionQuery::~PlatformOcclusionQuery()
{
	delete mHardwareOcclusionQuery;
}
//-----------------------------------------------------------------------
void PlatformOcclusionQuery::BeginQuery() const
{
	mHardwareOcclusionQuery->beginOcclusionQuery();
}
//-----------------------------------------------------------------------
void PlatformOcclusionQuery::EndQuery() const
{
	mHardwareOcclusionQuery->endOcclusionQuery();
}
//-----------------------------------------------------------------------
bool PlatformOcclusionQuery::GetQueryResult(unsigned int &visiblePixels, 
											const bool waitForResult) const
{
	return mHardwareOcclusionQuery->pullOcclusionQuery(&visiblePixels, waitForResult);
}

} // namespace Ogre